import * as React from "react";
import { DiagramEngine, DiagramModel } from "storm-react-diagrams";
import "storm-react-diagrams/dist/style.min.css";
import { IDiagramProps } from "./interfaces/diagram";
import { IDatabaseTable } from "./interfaces/table";
import { ReactDatabaseDiagramNodeModel } from "./diagram/models/NodeModel";
import "./styles/ReactDatabaseDiagram.css";
interface IReactDatabaseDiagramProps {
    schema: IDatabaseTable[];
    config?: IDiagramProps;
}
declare type ReactDatabasDiagramProps = IReactDatabaseDiagramProps;
/**
 * A react component to render nice database diagram using storm-react-diagrams
 *
 * @class ReactDatabaseDiagram
 * @extends {React.Component<ReactDatabasDiagramProps>}
 */
declare class ReactDatabaseDiagram extends React.Component<ReactDatabasDiagramProps> {
    static defaultProps: {
        allowLooseLinks: boolean;
        allowCanvasTranslation: boolean;
        allowCanvasZoom: boolean;
        maxNumberPointsPerLink: number;
        smartRouting: boolean;
    };
    engine: DiagramEngine;
    model: DiagramModel;
    private sceneNodes;
    private sceneLinks;
    constructor(props: IReactDatabaseDiagramProps);
    componentDidMount(): void;
    registerEngine: () => void;
    addToScene: (table: IDatabaseTable, index: number, child?: boolean | undefined) => ReactDatabaseDiagramNodeModel | undefined;
    updateDiagram(): void;
    getDistributedModel: (engine: DiagramEngine, model: DiagramModel) => DiagramModel;
    render(): JSX.Element;
}
export default ReactDatabaseDiagram;
