import { DiagramEngine, NodeModel } from "storm-react-diagrams";
import { IDatabaseTable } from "../../interfaces/table";
import { ReactDatabaseDiagramPortModel } from "./PortModel";
export declare class ReactDatabaseDiagramNodeModel extends NodeModel {
    ports: {
        [s: string]: ReactDatabaseDiagramPortModel;
    };
    data: IDatabaseTable;
    constructor(data?: IDatabaseTable);
    serialize(): {
        id: string;
    } & {
        type: string;
        selected: boolean;
    } & {
        x: number;
        y: number;
        extras: any;
        ports: ({
            id: string;
        } & {
            type: string;
            selected: boolean;
        } & {
            name: string;
            parentNode: string;
            links: string[];
            maximumLinks: number;
        })[];
    } & {
        data: IDatabaseTable;
    };
    deSerialize(ob: any, engine: DiagramEngine): void;
    getPort(name: string): ReactDatabaseDiagramPortModel | null;
    getPorts(): {
        [s: string]: ReactDatabaseDiagramPortModel;
    };
    getInPorts(): ReactDatabaseDiagramPortModel[];
    getOutPorts(): ReactDatabaseDiagramPortModel[];
}
