"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var storm_react_diagrams_1 = require("storm-react-diagrams");
var PortModel_1 = require("./PortModel");
var ReactDatabaseDiagramNodeModel = /** @class */ (function (_super) {
    __extends(ReactDatabaseDiagramNodeModel, _super);
    function ReactDatabaseDiagramNodeModel(data) {
        var _this = _super.call(this, "react-database-diagram") || this;
        _this.addPort(new PortModel_1.ReactDatabaseDiagramPortModel("top"));
        _this.addPort(new PortModel_1.ReactDatabaseDiagramPortModel("right"));
        _this.addPort(new PortModel_1.ReactDatabaseDiagramPortModel("bottom"));
        _this.addPort(new PortModel_1.ReactDatabaseDiagramPortModel("left"));
        _this.data = data;
        return _this;
    }
    ReactDatabaseDiagramNodeModel.prototype.serialize = function () {
        return _.merge(_super.prototype.serialize.call(this), {
            data: this.data,
        });
    };
    ReactDatabaseDiagramNodeModel.prototype.deSerialize = function (ob, engine) {
        var _this = this;
        _super.prototype.deSerialize.call(this, ob, engine);
        this.x = ob.x;
        this.y = ob.y;
        this.data = ob.data;
        _.forEach(ob.ports, function (port) {
            var portOb = engine
                .getPortFactory(port.type)
                .getNewInstance();
            portOb.deSerialize(port, engine);
            _this.addPort(portOb);
        });
    };
    ReactDatabaseDiagramNodeModel.prototype.getPort = function (name) {
        return this.ports[name];
    };
    ReactDatabaseDiagramNodeModel.prototype.getPorts = function () {
        return this.ports;
    };
    ReactDatabaseDiagramNodeModel.prototype.getInPorts = function () {
        return _.filter(this.ports, function (portModel) { return portModel.in; });
    };
    ReactDatabaseDiagramNodeModel.prototype.getOutPorts = function () {
        return _.filter(this.ports, function (portModel) { return !portModel.in; });
    };
    return ReactDatabaseDiagramNodeModel;
}(storm_react_diagrams_1.NodeModel));
exports.ReactDatabaseDiagramNodeModel = ReactDatabaseDiagramNodeModel;
//# sourceMappingURL=NodeModel.js.map