/// <reference types="react" />
import { BaseWidget, BaseWidgetProps, DefaultLabelModel, DiagramEngine } from "storm-react-diagrams";
import { IColumn, IDatabaseTable } from "../../interfaces/table";
import { ReactDatabaseDiagramNodeModel } from "../models/NodeModel";
export interface IReactDatabaseDiagramNodeWidgetProps extends BaseWidgetProps {
    node: ReactDatabaseDiagramNodeModel;
    engine: DiagramEngine;
}
export interface IReactDatabaseDiagramWidgetState {
    primaryKeys: IColumn[];
    foreignKeys: IColumn[];
    restColumns: IColumn[];
}
export declare class ReactDatabaseDiagramNodeWidget extends BaseWidget<IReactDatabaseDiagramNodeWidgetProps, IReactDatabaseDiagramWidgetState> {
    static defaultProps: IReactDatabaseDiagramNodeWidgetProps;
    columns: IColumn[];
    constructor(props: IReactDatabaseDiagramNodeWidgetProps);
    componentWillMount(): void;
    generatePort(port: DefaultLabelModel): JSX.Element;
    makeDataColumns: (columns: IColumn[]) => IColumn[];
    extractData: (data: IDatabaseTable) => void;
    render(): JSX.Element;
}
export default ReactDatabaseDiagramNodeWidget;
