"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var _ = require("lodash");
var storm_react_diagrams_1 = require("storm-react-diagrams");
var NodeModel_1 = require("../models/NodeModel");
var ReactDatabaseDiagramNodeWidget = /** @class */ (function (_super) {
    __extends(ReactDatabaseDiagramNodeWidget, _super);
    function ReactDatabaseDiagramNodeWidget(props) {
        var _this = _super.call(this, "react-database-diagram-node", props) || this;
        _this.makeDataColumns = function (columns) {
            return _.map(columns, function (column) {
                return _.merge(column, _.find(_this.columns, { name: column.name }));
            });
        };
        _this.extractData = function (data) {
            _this.columns = _.get(data, "columns");
            var primaryKeys = _.map(_.get(data, "primary_keys"), function (name) { return ({ name: name }); });
            primaryKeys = _this.makeDataColumns(primaryKeys);
            var foreignKeys = _.map(_.sortBy(_.flatMap(_.get(data, "foreign_keys"), "fromColumns")), function (column) { return ({ name: column }); });
            foreignKeys = _.differenceBy(foreignKeys, primaryKeys, "name");
            foreignKeys = _this.makeDataColumns(foreignKeys);
            var restColumns = _.differenceBy(_.map(_.flatMap(_this.columns, "name"), function (name) { return ({ name: name }); }), primaryKeys, foreignKeys, "name");
            restColumns = _this.makeDataColumns(restColumns);
            _this.setState({
                primaryKeys: primaryKeys,
                foreignKeys: foreignKeys,
                restColumns: restColumns,
            });
        };
        return _this;
    }
    ReactDatabaseDiagramNodeWidget.prototype.componentWillMount = function () {
        this.extractData(this.props.node.data);
    };
    ReactDatabaseDiagramNodeWidget.prototype.generatePort = function (port) {
        return React.createElement(storm_react_diagrams_1.DefaultLabelWidget, { model: port, key: port.id });
    };
    ReactDatabaseDiagramNodeWidget.prototype.render = function () {
        var _this = this;
        var node = this.props.node;
        var _a = this.state, primaryKeys = _a.primaryKeys, foreignKeys = _a.foreignKeys, restColumns = _a.restColumns;
        return (React.createElement("div", __assign({}, this.getProps(), { className: "" + this.bem("") }),
            React.createElement("div", { style: {
                    position: "absolute",
                    zIndex: 10,
                    display: "flex",
                    justifyContent: "center",
                    width: "100%",
                } },
                React.createElement(storm_react_diagrams_1.PortWidget, { name: "top", node: node })),
            React.createElement("div", { style: {
                    position: "absolute",
                    zIndex: 10,
                    right: 0,
                    display: "flex",
                    justifyContent: "center",
                    width: "100%",
                } },
                React.createElement(storm_react_diagrams_1.PortWidget, { name: "right", node: node })),
            React.createElement("div", { style: {
                    position: "absolute",
                    zIndex: 10,
                    bottom: 0,
                    display: "flex",
                    justifyContent: "center",
                    width: "100%",
                } },
                React.createElement(storm_react_diagrams_1.PortWidget, { name: "bottom", node: node })),
            React.createElement("div", { style: {
                    position: "absolute",
                    zIndex: 10,
                    left: 0,
                    display: "flex",
                    justifyContent: "center",
                    width: "100%",
                } },
                React.createElement(storm_react_diagrams_1.PortWidget, { name: "left", node: node })),
            React.createElement("div", { className: "" + this.bem("__title") },
                React.createElement("div", { className: "" + this.bem("__name") }, node.data.table_name)),
            React.createElement("div", null,
                React.createElement("div", { className: "" + this.bem("__columns") },
                    primaryKeys.map(function (column, index) { return (React.createElement("div", { className: "" + _this.bem("__column"), key: index },
                        React.createElement("div", { className: _this.bem("__columnType--PK") + " " + _this.bem("__text--bold") }, "PK"),
                        React.createElement("div", { className: _this.bem("__columnName--PK") + " " + _this.bem("__text--bold") },
                            column.name,
                            " : ",
                            React.createElement("span", null, column.type)))); }),
                    foreignKeys.map(function (column, index) { return (React.createElement("div", { className: "" + _this.bem("__column"), key: index },
                        React.createElement("div", { className: _this.bem("__columnType") + " " + _this.bem("__text--italic") }, "FK"),
                        React.createElement("div", { className: "" + _this.bem("__columnName") },
                            column.name,
                            " :",
                            " ",
                            React.createElement("span", { className: "" + _this.bem("__text--italic") }, column.type)))); }),
                    restColumns.map(function (column, index) { return (React.createElement("div", { className: "" + _this.bem("__column"), key: index },
                        React.createElement("div", { className: "" + _this.bem("__columnType") }),
                        React.createElement("div", { className: "" + _this.bem("__columnName") },
                            column.name,
                            " :",
                            " ",
                            React.createElement("span", { className: "" + _this.bem("__text--italic") }, column.type)))); })))));
    };
    ReactDatabaseDiagramNodeWidget.defaultProps = {
        node: new NodeModel_1.ReactDatabaseDiagramNodeModel(),
        engine: new storm_react_diagrams_1.DiagramEngine(),
    };
    return ReactDatabaseDiagramNodeWidget;
}(storm_react_diagrams_1.BaseWidget));
exports.ReactDatabaseDiagramNodeWidget = ReactDatabaseDiagramNodeWidget;
exports.default = ReactDatabaseDiagramNodeWidget;
//# sourceMappingURL=NodeWidget.js.map